//
//  AppManager.swift
//  sample
//
//  Created by CITIZEN Watch Co.,Ltd on 2019/10/28.
//  Copyright © 2019 CITIZEN Watch Co.,Ltd. All rights reserved.
//

import Foundation
import UIKit

/// The class to manage providing the app infomation to Riiiver SDK..    -    RiiiverSDKで使用するアプリ情報を管理
class AppManager {
    // Singleton
    static let shared = AppManager()
    
    /// ベンダーIDを取得する
    /// Getter -   Get the company ID.
    /// - Returns: company ID,  ベンダーID
    func getVendorId() -> String {
        return "Your Vendor ID here!"
    }
    
    /// デバイスIDを取得する
    ///  Getter - Get the device model ID.
    /// - Returns: device model ID, デバイス(モデル)ID
    func getDeviceId() -> [String] {
        return ["Your Device ID here!"]
    }
    
    /// アプリ名を取得する
    ///  Getter  - Get the App name.
    /// - Returns: App name
    func getAppName() -> String {
        return "Your appname here!"
    }
    
    /// ユーザーエージェントを取得する
    /// Get the user agent information
    /// - Returns: The information of user agent.
    func getUserAgent() -> String {
        let appName = getAppName()
        let appVersion = Bundle.main.object(forInfoDictionaryKey: "CFBundleShortVersionString")
        let osNameVersion: String = {
            let version = ProcessInfo.processInfo.operatingSystemVersion
            let versionString = "\(version.majorVersion).\(version.minorVersion).\(version.patchVersion)"
            let osName: String = {
                #if os(iOS)
                return "iOS"
                #elseif os(watchOS)
                return "watchOS"
                #elseif os(tvOS)
                return "tvOS"
                #elseif os(macOS)
                return "OS X"
                #elseif os(Linux)
                return "Linux"
                #else
                return "Unknown"
                #endif
            }()
            return "\(osName)/\(versionString)"
        }()
        return "\(appName)/\(appVersion!) \(osNameVersion)"
    }

    static let riiiverAuthUri = "https://builder.developer.riiiver.com/service_oauth/"

}
