//
//  ViewController.swift
//  sample
//
//  Created by CITIZEN Watch Co.,Ltd on 2019/10/23.
//  Copyright © 2019 CITIZEN Watch Co.,Ltd. All rights reserved.
//

import Foundation
import UIKit
import WebKit

class ViewController: UIViewController, ERSDKLoginWebViewDelegate {
    /// 認証用WebView   -    Web view for the authentication.
    @IBOutlet weak var webLogin: WKWebView!
    
    override func viewDidLoad() {
        super.viewDidLoad()
    }
    
    override func viewDidAppear(_ animated: Bool) {
        if (RiiiverSDKManager.shared.authenticated == false ){
            // Web認証画面表示  -  Display the webview for the authentication.
            RiiiverSDKManager.shared.setWebView(viewController: self, webView: webLogin, delegate: self)
        }
        else {
            // 既に認証済みの場合は次の画面へ - If the user have already authenticated, goto next ViewController.
            nextViewController()
        }
    }
    
    func onCloseViewController(_ viewController: UIViewController) {
        print("onCloseViewController")
        nextViewController()
    }
    
    func nextViewController() {
        self.performSegue(withIdentifier: "toSample", sender: self)
    }
    
    func onError(_ err: Error) {
        print("onError")
    }
    
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        if let sampleViewController = segue.destination as? SampleViewController {
            sampleViewController.isReload = true
        }
    }
}
